{
Avansin apyskaita:
  Debeto_suma   - Debeto suma
  Kredito_suma  - Kredito suma
  Firma         - Firmos sskaita
  Darbuotojas   - Darbuotojo sskaita


  jei Debeto_suma > 0
  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  Darbuotojas                  | Firma                       | Debeto_suma

  jei Kredito_suma > 0
  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  Firma                        | Darbuotojas                 | Kredito_suma
}
{
Rezultatas:
   [x]     - grup
   [x+1]   - debetas
   [x+2]   - kreditas
   [x+3]   - suma
}

function Operacija(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikms: VarArray [0..N] of variant
  ): Variant;

var
  rez: Variant;
  Debeto_suma: currency;
  Kredito_suma: currency;
  Firma: string;
  Darbuotojas: string;

  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i:=VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Break;
      end;
    end;
  end;

begin
  Debeto_suma := Rasti('Debeto_suma');
  Kredito_suma := Rasti('Kredito_suma');
  Firma := Rasti('Firma');
  Darbuotojas := Rasti('Darbuotojas');

  rez := VarArrayCreate([0,3], varVariant);
  if Debeto_suma > 0 then begin // gauta is firmos
    rez[0] := 1;
    rez[1] := Darbuotojas;    // debetas
    rez[2] := Firma;  // kreditas
    rez[3] := Debeto_suma;
  end else if Kredito_suma > 0 then begin // sumoketa firmai
    rez[0] := 1;
    rez[1] := Firma;  // debetas
    rez[2] := Darbuotojas;    // kreditas
    rez[3] := Kredito_suma;
  end;
  Result := rez;
end;

begin
end.

