const
  MaxPeriodas = 6; // apyvartos skaiiavimo periodas mnesiais

function SFNuolaida(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikms: VarArray [0..N] of variant
  ): double;
var
  Klientas: integer;
  DataIki: TDateTime;
  DataNuo: TDateTime;
  Apyvarta: currency;
  Menuo: integer;

  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i := VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Exit;
      end;
    end;
    ShowMessage(Kas + ' = Unassigned');
  end;

begin
  Result := 2;

  Klientas := Rasti('Klientas');
  DataIki := IncDay(Data, -1);
  DataNuo := IncMonth(DataIki, -MaxPeriodas);
  Apyvarta := KlientoPirkimai(Klientas, DataNuo, DataIki) * 1.18;

  if Apyvarta >= 5000 then Result := 15
  else if Apyvarta >= 3000 then Result := 14
  else if Apyvarta >= 1500 then Result := 13
  else if Apyvarta >= 1000 then Result := 12
  else if Apyvarta >=  750 then Result := 11
  else if Apyvarta >=  500 then Result := 10
  else if Apyvarta >=  300 then Result :=  9
  else if Apyvarta >=  200 then Result :=  8
  else if Apyvarta >=  150 then Result :=  7
  else if Apyvarta >=  100 then Result :=  6
  else if Apyvarta >=   75 then Result :=  5
  else if Apyvarta >=   50 then Result :=  4
  else if Apyvarta >=   30 then Result :=  3
  else Result := 2;

  Menuo := 1;
  while (Result > 2) and (Menuo < MaxPeriodas) do begin
    Apyvarta := KlientoPirkimai(Klientas, IncMonth(DataIki, -Menuo), DataIki);
    if Apyvarta <> 0 then Break;

    Result := Result - 1;
    Menuo := Menuo + 1;
  end;
end;

begin
end.

