{
Ilgalaikis turtas:
  Savikaina[1]      - Savikainos sskaitos
  Perkainavimas[1]  - Perkainavimo sskaita
  Savikainos_nusidevejimas[1]  - Savikainos nusidvjimo sskaita
  Vertes_sumazejimas[1]  - Verts sumajimo sskaita
  Sanaudos[1]       - Snaud sskaita

  Savikainos_suma[1] - Savikainos suma
  Perkainavimo_suma[1] - Perkainavimo suma
  Savikainos_nusidevejimo_suma[1] - Savikainos nusidvjimo suma
  Vertes_sumazejimo_suma[1] - Verts sumajimo suma
  Sanaudu_suma[1]   - Snaud suma


  -----------------------------|-----------------------------|----------------------------
  Debetas                      | Kreditas                    | suma
  -----------------------------|-----------------------------|----------------------------
  Sanaudos [1]                 | Savikainos_nusidevejimas [1]| Snaud suma [1]

  viso rau: [1]
}
{
Rezultatas:
   [x]     - grup
   [x+1]   - debetas
   [x+2]   - kreditas
   [x+3]   - suma
}

function Operacija(
  Data: TDateTime;
  Kintamieji: Variant; // kintamieji: VarArray [0..N] of String
  Value: Variant       // reikms: VarArray [0..N] of variant
  ): Variant;

var
  rez: Variant;

  Savikaina: Variant;
  Perkainavimas: Variant;
  Savikainos_nusidevejimas: Variant;
  Vertes_sumazejimas: Variant;
  Sanaudos: Variant;

  Savikainos_suma: Variant;
  Perkainavimo_suma: Variant;
  Savikainos_nusidevejimo_suma: Variant;
  Vertes_sumazejimo_suma: Variant;
  Sanaudu_suma: Variant;

  iIndex: integer;
  i1: integer;
  i2: integer;
  i: integer;

  v: Variant;

  function Rasti(Kas: String): Variant;
  var
    i: integer;
  begin
    Result := Unassigned;
    for i := VarArrayLowBound(Kintamieji,1) to VarArrayHighBound(Kintamieji,1) do begin
      if Uppercase(Kas) = Uppercase(Kintamieji[i]) then begin
        Result := Value[i];
        Exit;
      end;
    end;
    ShowMessage(Kas + ' = Unassigned');
  end;

  procedure VarToVarArray(var v:variant);
  var
    vTmp: variant;
  begin
    if (VarType(v) and varArray) = 0 then begin
      vTmp := v;
      v := VarArrayCreate([0,0], varVariant);
      v[0] := vTmp;
    end;
  end;

begin

  Savikaina := Rasti('Savikaina');
  Perkainavimas := Rasti('Perkainavimas');
  Savikainos_nusidevejimas := Rasti('Savikainos_nusidevejimas');
  Vertes_sumazejimas := Rasti('Vertes_sumazejimas');
  Sanaudos := Rasti('Sanaudos');

  VarToVarArray(Savikaina);
  VarToVarArray(Perkainavimas);
  VarToVarArray(Savikainos_nusidevejimas);
  VarToVarArray(Vertes_sumazejimas);
  VarToVarArray(Sanaudos);

  Savikainos_suma := Rasti('Savikainos_suma');
  Perkainavimo_suma := Rasti('Perkainavimo_suma');
  Savikainos_nusidevejimo_suma := Rasti('Savikainos_nusidevejimo_suma');
  Vertes_sumazejimo_suma := Rasti('Vertes_sumazejimo_suma');
  Sanaudu_suma := Rasti('Sanaudu_suma');

  VarToVarArray(Savikainos_suma);
  VarToVarArray(Perkainavimo_suma);
  VarToVarArray(Savikainos_nusidevejimo_suma);
  VarToVarArray(Vertes_sumazejimo_suma);
  VarToVarArray(Sanaudu_suma);

  i1 := VarArrayHighBound(Sanaudos,1)-VarArrayLowBound(Sanaudos,1)+1;

  rez := VarArrayCreate([0,(i1)*4-1], varVariant);

  iIndex := 0;
  // Debetas                      | Kreditas                    | suma
  // -----------------------------|-----------------------------|----------------------------
  // Sanaudos [1]                 | Savikainos_nusidevejimas [1]| Snaud suma [1]
  for i := 0 to i1-1 do begin
    rez[iIndex+0] := 1;
    rez[iIndex+1] := Sanaudos[i];               // debetas
    rez[iIndex+2] := Savikainos_nusidevejimas[i];     // kreditas
    rez[iIndex+3] := Sanaudu_suma[i];
    iIndex := iIndex + 4;
  end;

  Result := rez;
end;

begin
end.

